clc;
clear;

file_list=[11,18,26];
raw_data = [1, 1, 1];
root_dir = '..\Soyoung_Gallis_040905_';
overlap_ratio = zeros(3, 1);

for file_index=1:3
    sel_file = file_list(file_index);
    sel_raw_file = [root_dir, sprintf('%02d', file_list(file_index)), '\', num2str(raw_data(file_index)), '.txt'];
    raw_file_content = load(sel_raw_file);
    mz_value = raw_file_content(:,1);
    refer_content = load(['Soyoung_Gallis_040905_', sprintf('%02d', file_list(file_index)), '_refer.txt']);
    refer_content = refer_content(:, 1);
    info_content = load(['Soyoung_Gallis_040905_', sprintf('%02d', file_list(file_index)), '_info.txt']);
    analyzed_refer = load(['refer', num2str(file_list(file_index)), '.txt']);
    analyzed_refer = analyzed_refer(:, 1);
    raw_ms_file_list = dir([root_dir, sprintf('%02d', file_list(file_index)), '\*.txt']);
    scan_number  = length(raw_ms_file_list);
    raw_ms_file_index = zeros(scan_number, 1);
    for i=1:scan_number
        file_name = raw_ms_file_list(i).name;
        end_index = find(file_name == '.');
        raw_ms_file_index(i) = str2double(file_name(1:end_index-1));
    end
    raw_ms_file_index = sort(raw_ms_file_index);
    map_result = sparse(scan_number, length(mz_value));
    peptide_mass = zeros(length(analyzed_refer), 3);
    analyzed_column = zeros(length(analyzed_refer), 1);
    for i=1:length(analyzed_refer)
       match_index = find(refer_content == analyzed_refer(i), 1, 'first');
       analyzed_column(i) = match_index;
       refer_content(match_index) = 0;
    end
    analyzed_column = sort(analyzed_column);
    file_reader = fopen(['Soyoung_Gallis_040905_', sprintf('%02d', file_list(file_index)), '_seq.txt'], 'r');
    process_index=1;
    finish_index = 1;
    modification_count = (size(info_content, 2) - 7)/2;
    while 1
        read_line = fgetl(file_reader);
        if ~ischar(read_line)
            break;
        end
        if process_index == analyzed_column(finish_index)
           peptide_che = GeneratePeptide(read_line);
           charge_state = info_content(process_index, 2);
           [mass, intensity] = EstimateIsotope(peptide_che,charge_state, 0);
           add_modi = 0;
           for modi_index = 1:modification_count
                sel_modi = 7 + (modi_index - 1 ) * 2 + 1;
                add_modi = add_modi + info_content(process_index, sel_modi) * info_content(process_index, sel_modi + 1);
           end
           peptide_mass(finish_index, :) = mass(1:3) + add_modi / charge_state;
           finish_index = finish_index + 1;
        end
        if finish_index > length(analyzed_column)
            break;
        end
        process_index = process_index + 1;
    end
    fclose(file_reader);
    overlap_count = 0;
    for i=1:length(analyzed_refer)
        disp([num2str(i), ' out of ',num2str(length(analyzed_refer))]);
        less_than_list = raw_ms_file_index(raw_ms_file_index <= info_content(i, 1));
        match_index = find(raw_ms_file_index == less_than_list(end));
        if length(match_index) ~= 1
            disp('error');
        end
        abs_distance = abs(mz_value - peptide_mass(i, 1));
        begin_mz_index = find(abs_distance == min(abs_distance), 1, 'first');
        abs_distance = abs(mz_value - peptide_mass(i, 3));
        end_mz_index = find(abs_distance == min(abs_distance), 1, 'first');
        map_begin = max(1, (match_index-12));
        map_end = min((match_index+12), scan_number);
        map_result(map_begin:map_end, begin_mz_index:end_mz_index) = map_result(map_begin:map_end, begin_mz_index:end_mz_index) + 1;
        overlap_index = find(map_result >= 2);
        if isempty(overlap_index) == 0
            map_result(overlap_index) = 1;
            overlap_count = overlap_count + 1;
        end
    end
    overlap_ratio(file_index)  =overlap_count / length(analyzed_refer);
end

file_writer = fopen('overlapping_ratio.txt', 'w');
fprintf(file_writer, '%f\n', overlap_ratio);
fclose(file_writer);